function p = optionsList(choice)
%OPTIONSLIST List of all GA and PS options.

%   Copyright 2003-2007 The MathWorks, Inc.

p = [];
switch lower(choice)
    case 'ga'
        p = {
            'PopulationType'
            'PopInitRange'
            'PopulationSize'
            'EliteCount'
            'CrossoverFraction'
            'MigrationDirection'
            'MigrationInterval'
            'MigrationFraction'
            'Generations'
            'TimeLimit'
            'FitnessLimit'
            'StallGenLimit'
            'StallTimeLimit'
            'TolFun'
            'TolCon'
            'InitialPopulation'
            'InitialScores'
            'InitialPenalty'
            'PenaltyFactor'
            'PlotInterval'
            'FitnessScalingFcn'
            'SelectionFcn'
            'CrossoverFcn'
            'MutationFcn'
            'Display'
            'PlotFcns'
            'OutputFcns'
            'CreationFcn'
            'HybridFcn'
            'Vectorized'
            'DistanceMeasureFcn'
            'ParetoFraction'
        };
        
    case 'ps'
        p = {
            'TolMesh'
            'TolCon'
            'TolX'
            'TolFun'
            'TolBind'
            'MaxIter'
            'TimeLimit'
            'MaxFunEvals'
            'MeshContraction'
            'MeshExpansion'
            'MeshAccelerator'
            'MeshRotate'
            'InitialMeshSize'
            'InitialPenalty'
            'PenaltyFactor'
            'ScaleMesh'
            'MaxMeshSize'
            'PollMethod'
            'CompletePoll'
            'PollingOrder'
            'SearchMethod'
            'CompleteSearch'
            'Display'
            'OutputFcns'
            'PlotFcns'
            'PlotInterval'
            'Cache'
            'CacheSize'
            'CacheTol'
            'Vectorized'
        };
    
    case 'sa'
        p = {
            'AnnealingFcn'
            'TemperatureFcn'
            'TolFun'
            'StallIterLimit'
            'TimeLimit'
            'MaxIter'
            'InitialTemperature'
            'Display'
            'HybridFcn'
            'HybridInterval'
            'MaxFunEvals'
            'ReannealInterval'
            'DisplayInterval'
            'PlotFcns'
            'OutputFcns'
            'AcceptanceFcn'
            'PlotInterval'
        };
 
end
