function [total_cost, production, stored_energy_after] =economic_dispatch2(active,temporary_vars, power_demand, tech_lim, time)
%global temporary_vars power_demand tech_lim time; %violations

p=temporary_vars.previous_production; % Last power value of last 24h cycle.
stored_energy_after=temporary_vars.stored_energy_before;
temp1=(reshape(active, [time, tech_lim.L]));
temp2=transpose(temp1);

active_units=temp1(:,1:tech_lim.L1);
active_storage=temp1(:,tech_lim.L1+1:tech_lim.L);

fuel_cost=zeros(1, time);
prices=tech_lim.specific_energy_prices(temporary_vars.index:temporary_vars.index+time-1,:);
prices(~active_units)=-1;
production=zeros(time,tech_lim.L1+1);

% First iteration:
lb=max(p(1:tech_lim.L1)-tech_lim.ramp_rate, tech_lim.min_on_power);
ub=max(min(p(1:tech_lim.L1)+tech_lim.ramp_rate, 1), tech_lim.min_on_power);  % if(p+ramp_rate<min_on_power) => ub=min_on_power
[p, fuel_cost(1), stored_energy_after]=dispatch_s2(lb, ub, prices(1,:), ...
    power_demand(temporary_vars.index), active_units(1,:), active_storage(1,:), stored_energy_after,...
    tech_lim.installed_power, tech_lim.storage_capacity, tech_lim.storage_power, tech_lim.L1, tech_lim.L2, tech_lim.storage_efficiency,...
    tech_lim.limitations);

production(1,:)=p;
p(1:tech_lim.L1)=p(1:tech_lim.L1)./tech_lim.installed_power;

for i=2:time
    % Setting upper and lower bounds
    lb=max(p(1:tech_lim.L1)-tech_lim.ramp_rate, tech_lim.min_on_power);
    ub=max(min(p(1:tech_lim.L1)+tech_lim.ramp_rate, 1), tech_lim.min_on_power);
    
    % Dispatching load to active generators to find the cost
    [p, fuel_cost(i), stored_energy_after]=dispatch_s2(lb, ub, prices(i,:), ...
        power_demand(temporary_vars.index+i-1), active_units(i,:), active_storage(i,:), stored_energy_after,...
        tech_lim.installed_power, tech_lim.storage_capacity, tech_lim.storage_power, tech_lim.L1, tech_lim.L2, tech_lim.storage_efficiency...
        , tech_lim.limitations);

% Preparing for next iteration
    production(i,:)=p;
    p(1:tech_lim.L1)=p(1:tech_lim.L1)./tech_lim.installed_power;
end

[total_start_cost, total_standby_cost]=find_down_time_violations(temp2(1:tech_lim.L1,:), tech_lim.start_cost(temporary_vars.index:temporary_vars.index+time-1,:)...
   ,tech_lim.start_cost2 , tech_lim.min_down_time, temporary_vars.down_time_before, temporary_vars.up_time_before, tech_lim.standby_cost, tech_lim.has_standby_cost, tech_lim.L1,  time);
total_cost=sum(fuel_cost)+total_start_cost+total_standby_cost; % penalty=600000
