function [total_start_cost, total_standby_cost]=find_down_time_violations(transposed_active, start_cost, start_cost2, min_down_time, current_down_time, current_up_time, standby_cost, has_standby_cost, L1, time)

[DTorUT, isTurnedOn, isTurnedOff, not_active]=find_down_time(transposed_active, current_down_time, current_up_time,has_standby_cost, L1, time);

% Find standby hours for relevant units

DTless12=DTorUT(has_standby_cost,:)<12;
warm_start=isTurnedOn;
warm_start(has_standby_cost,~DTless12)=false; % | transpose(not(has_standby_cost)));
cold_start=isTurnedOn(has_standby_cost,:) & ~warm_start(has_standby_cost,:);

% add hours 3-12, if turned on after 12 remove 3-12
total_standby_cost=sum(standby_cost(has_standby_cost)*(DTless12 & not_active(has_standby_cost,:) & DTorUT(has_standby_cost,:)>transpose(min_down_time(has_standby_cost))...
-cold_start*7));
% find start costs
total_start_cost=sum(start_cost2(has_standby_cost)*cold_start+sum(transpose(start_cost).*warm_start));
%violations=struct('DTorUT',DTorUT,'isTurnedOn',isTurnedOn,'isTurnedOff',isTurnedOff);
% total_start_cost=1;
% total_standby_cost=0;

% Alternative code:

%     isTurnedOn(i,:)=[current_down_time(i)>0 && transposed_active(i,1), diff(transposed_active(i,:))==1];
%     isTurnedOff(i,:)=[current_up_time(i)>0 && not_active(i,1), diff(transposed_active(i,:))==-1];

% k=current_down_time(i);
% if k==0
%     k=[];
% end
%     a=find(isTurnedOn(i,:));
%     b=[-k, find(isTurnedOff(i,:))];
%     DTorUT(i, isTurnedOn(i,:))=a-b(1:numel(a));
