function [bestSolution, bestScore]=repair(solution, score, FitnessFcn, L1, time,temporary_vars, tech_lim)
%global tech_lim temporary_vars
temp1=(reshape(solution, [time, tech_lim.L]));
transposed_active=transpose(temp1);

[DTorUT, isTurnedOn, ~]=find_down_time(transposed_active(1:L1,:), temporary_vars.down_time_before, temporary_vars.up_time_before,tech_lim.has_standby_cost, L1, time);


newSolutions(1:2,:)=repmat(solution, 2,1);
newScore=ones(2,1)*score;
indexOfBest=1;

v=1:time;
w=1:L1;
point_of_violation=isTurnedOn & DTorUT<transpose(tech_lim.min_down_time);
is_violated=w(sum(point_of_violation, 2)>0 );

for i=is_violated
    index2=v(point_of_violation(i,:));
    index1=index2-DTorUT(i,index2);
    %     index1(index1<=0)=1;
    index3=index2+tech_lim.min_down_time(i)-DTorUT(i,index2)-1;
    index3(index3>time)=time;
%     k=v(index1>circshift(index3, -1));
%     k(end)=[];
%     index1(k+1)=[];
%     index3(k)=[];
%     remove index1 of 2, remove index3 of 1
%     
    if index1(1)<=0
        index1(1)=1;
        interval=time*(i-1)+index1(1):time*(i-1)+index3(1);
        newSolutions(:,interval)=0;
    else
        interval=time*(i-1)+index1(1):time*(i-1)+index3(1);     
        newSolutions(1, interval)=1;
        newSolutions(2, interval)=0;
        newScore(1)=FitnessFcn(newSolutions(1,:));
        newScore(2)=FitnessFcn(newSolutions(2,:));
        [~,indexOfBest]=min(newScore);
        newSolutions(:,interval)=repmat(newSolutions(indexOfBest, interval),2,1);
    end
    
    elements=numel(index2);
    if elements>=2
        for j=2:elements
            interval=time*(i-1)+index1(j):time*(i-1)+index3(j);
            
            newSolutions(1, interval)=1;
            newSolutions(2, interval)=0;
            newScore(1)=FitnessFcn(newSolutions(1,:));
            newScore(2)=FitnessFcn(newSolutions(2,:));
            [~,indexOfBest]=min(newScore);
            newSolutions(:,interval)=repmat(newSolutions(indexOfBest, interval),2,1);
        end
    end
end

bestSolution=newSolutions(1,:);
bestScore=newScore(indexOfBest);

% temp1=(reshape(bestSolution, [time, 53]));
% temp2=transpose(temp1);
% temp4=temp2(1:L1,:);