function [production_duration, active_duration, yearly_cost, energy_carrier, solution, cost,tech_lim]=x5_s(demand, elspotprices,timeData,prodEGE,storage_size)
% Optimizes unit commitment statuses and storage commitment
%global power_demand time tech_lim temporary_vars ;
%% Establishing production plant details %%
%[demand, elspotprices,prodEGE, timeData]=shiftVars(demand, elspotprices,prodEGE, timeData);


% Fixing demand by waste boilers
totalHours=length(demand);
[tech_lim, waste_power]=setTechLim(totalHours, elspotprices);
tech_lim.time=findSummerDays(timeData);
prodEGE(prodEGE>32)=32;
power_demand=demand-prodEGE-waste_power;
% power_demand(power_demand<0)=0;



% Getting technical limitations
energy_carrier=tech_lim.energy_carrier;
costEGE=setEGE(timeData,prodEGE);
%tech_lim.prodEGE=prodEGE;

% Initializing storage
storageEnabled=true;
tech_lim.storage_capacity=0*storage_size;   % 200 MWh energy capacity
tech_lim.storage_power=19;       % 20 MW production capacity
tech_lim.storage_efficiency=0.9;    % Storage dispatch efficiency
storage_units=0;        % At most 3 units can interact with storage

ws_name=string(['C:\Users\Marius\Documents\MATLAB\remote_run\run',char(string(tech_lim.storage_capacity)),'.mat']);
myVars={'temporary_vars','active_duration','production_duration','yearly_cost','cost','costEGE'};

% number of bits including storage
L1=length(tech_lim.installed_power);
L2=2*storage_units;
L=L1+L2;
tech_lim.L1=L1;
tech_lim.L2=L2;
tech_lim.L=L;


%% Optimization using genetic algorithm %%
%time=24;
% tech_lim.time=24; % Optimization on 24h basis
numvars=tech_lim.time*L;
hour_nr=cumsum([1;tech_lim.time]);

temporary_vars=setTemporaryVars(L1);

% Option selection
opts = optimoptions('ga','PopulationType','bitstring', ...
    'MaxStallGenerations', 50);
% ,'UseParallel',true 'CrossoverFcn',@crossovertwopoint  'FitnessScalingFcn', @fitscalingtop 'PlotFcn',@gaplotbestf); 'PopulationSize', 50,
% 'OutputFcn', @myoutput
A=[]; b=[]; lb=[]; ub=[]; yearly_cost=0;
tic;

startIt=1;
lastIt=1; %366 totalHours/tech_lim.time;
cost=zeros(1,lastIt-startIt+1);
duration=zeros(1,lastIt-startIt+1);
solution=cell(lastIt-startIt+1,1);
production_duration=[]; active_duration=[];
if storageEnabled
    for i=startIt:lastIt
   %  try
%          if i==1
% %              clear(myVars{:});
% %              load(ws_name,myVars{:});
% %              i=134;
%              production_duration=production_duration(1:sum(tech_lim.time(1:133)),:);
%              active_duration=active_duration(1:sum(tech_lim.time(1:133)),:);
%              temporary_vars.stored_energy_before=0;
%          end
         
            time=tech_lim.time(i);
            temporary_vars.index=hour_nr(i);
            duration_demand=power_demand(temporary_vars.index:temporary_vars.index+time-1);
            if sum(duration_demand>0)>0
                solution(i)={ga_modified(@(active)economic_dispatch2(active,temporary_vars, power_demand, tech_lim, time), numvars(i), A, b, [], [], lb, ub, [], [], opts,temporary_vars, tech_lim, time)};
                [cost(i), production, temporary_vars.stored_energy_before]=economic_dispatch2(solution{i},temporary_vars, power_demand, tech_lim, time);
                active=reshape(solution{i}, [ time,L]);
                active_duration=[active_duration;active];
                yearly_cost=yearly_cost+cost(i)+costEGE(i);
                production_duration=[production_duration;production];
                temporary_vars.is_enabled_before=active(time,1:L1);
                temporary_vars.previous_production=production(time,1:L1)./tech_lim.installed_power;
                [temporary_vars.down_time_before, temporary_vars.up_time_before]=find_down_time_before(active, temporary_vars.down_time_before, temporary_vars.up_time_before, L1,time);
                duration(i)=toc;
            else
                cost(i)=0;
                production=zeros(time,L1+1);
                active=zeros(time,L);
                yearly_cost=yearly_cost+cost(i)+costEGE(i);
                production_duration=[production_duration;production];
                active_duration=[active_duration;active];
                temporary_vars.stored_energy_before=min(tech_lim.storage_capacity, temporary_vars.stored_energy_before-sum(duration_demand));
                temporary_vars.is_enabled_before=zeros(1,L1);
                temporary_vars.previous_production=zeros(1,L1);
                [temporary_vars.down_time_before, temporary_vars.up_time_before]=find_down_time_before(active, temporary_vars.down_time_before, temporary_vars.up_time_before, L1, time);
            end
%         catch
%             i
%         end
    end
else
    %Storage disabled
    
end
toc
yearly_cost
try
save(ws_name);
catch
    yearly_cost;
end
end
% Ta opp:
% Avfallskjeler, alltid p/fast avslutning p sesong? minste effekt?
% For mye til  ha alle p om sommeren? Pris i wonderware 200ish/MWh
