function [relativeDailyVariation, annualRelativeDailyVariation, relativeHourlyVariation,storageSize,storagePower]=findRelativeDailyVariation(power_data)
l=length(power_data);
yearlyAverage=sum(power_data)/l;
dailyAverage=zeros(l,1);

relativeDailyVariation=zeros(1,l/24);
for i = 1:l
    if mod(i,24)==0 % && i~=l
        dailyAverage(i-23:i)=sum(power_data(i-23:i))/24;
        dailyAverageHeatLoad(i/24)=dailyAverage(i);
        relativeDailyVariation(i/24)=0.5*sum(abs(power_data(i-23:i)-dailyAverage(i-23:i)))*100/(yearlyAverage*24);
    end
end
annualRelativeDailyVariation=0.5*sum(abs(power_data-dailyAverage))*100/(l*yearlyAverage);
relativeDailyVariation=sort(relativeDailyVariation, 'descend');
dailyAverageHeatLoad=sort(dailyAverageHeatLoad, 'descend');
relativeHourlyVariation=abs(power_data-dailyAverage)*100/yearlyAverage;
relativeHourlyVariation=sort(relativeHourlyVariation, 'descend');

relativeDailyVariation(1:4)=[];
relativeHourlyVariation(1:ceil(0.01*length(relativeHourlyVariation)))=[];

L1=length(relativeDailyVariation);
L2=length(relativeHourlyVariation);
plot(1:L1, relativeDailyVariation);
xlabel('Day'); ylabel('Relative daily variation [%]');
figure(2) 
plot(1:L2, relativeHourlyVariation);
xlabel('Hour'); ylabel('Relative hourly variation [%]');


meanRDV=mean(relativeDailyVariation);
maxRDV=max(relativeDailyVariation);
% figure(1);
% hold on
% plot(1:L1,meanRDV*ones(1,L1))

meanRHV=mean(relativeHourlyVariation);
maxRHV=max(relativeHourlyVariation);
% figure(2)
% hold on
% plot(1:L2, meanRHV*ones(1,L2));


storageSize=yearlyAverage*meanRDV*24/100;
storagePower=meanRHV*yearlyAverage/100;
sizeMax=yearlyAverage*maxRDV*24/100;
powerMax=maxRHV*yearlyAverage/100;