function [share, beta_week]=fitNonLin(temp_power_fun, temp_data, power_data, hour_of_week, avg_temp, avg_power)
%% Non linear fitting %%
% temp_power_fun=@(b, T_out)...
%      b(1).*((T_out-b(2)).*0.5.*erfc((T_out-b(2))/(sqrt(2)*b(3)))-(b(3)/sqrt(2*pi))*exp(-(T_out-b(2)).^2/(2*b(3)^2)))+b(4);
% b=[a, T_0, sigma, P_0]
 
% temp_power_fun2=@(b, x)...
%     b(1).*((x(1)-b(2)).*0.5.*erfc((x(1)-b(2))/(sqrt(2)*b(3)))-(b(3)/sqrt(2*pi))*exp(-(x(1)-b(2)).^2/(2*b(3)^2)))+b(4)...
%     +x(:,5:168)*transpose(b(5:168));
 
 
beta0=[ -20, 15, 4, 20];
% beta0(5:173)=10;

opts = statset('nlinfit');
opts.RobustWgtFun = 'bisquare';

% beta = nlinfit(temp_data, power_data, temp_power_fun, beta0, opts);
beta_week=nlinfit(avg_temp, avg_power, temp_power_fun, beta0, opts);

% temp_power_fun(beta_week, temp_data(i))
j=1; hours=zeros(168,1); share=zeros(168,1); h=hour_of_week;
for i=1:length(temp_data)
    if(not(isnan(avg_power(j))) && not(isnan(temp_data(i))))
        share(h(i))=share(h(i))+power_data(i)/avg_power(j);
        hours(h(i))=hours(h(i))+1;
    end
    if(h(i)>=168)
        j=j+1;
    end
end
share=share./hours;



end