function [winter, spring, summer, autumn, season_power]...
    = split_by_season(power, temp, weekend_day, hour_of_day, cat_day_w, cat_hour_d, M, Year)

power=circshift(power, -1);
power(1)=nan;

% initializing structures
    winter.weekend_day=[];  winter.power=[];
    spring.weekend_day=[];  spring.power=[];
    summer.weekend_day=[];  summer.power=[];
    autumn.weekend_day=[];  autumn.power=[];
    
    winter.cat_hour_d=[];
    spring.cat_hour_d=[];
    summer.cat_hour_d=[];
    autumn.cat_hour_d=[];
    
    winter.cat_day_w=[];
    spring.cat_day_w=[];
    summer.cat_day_w=[];
    autumn.cat_day_w=[];
    
    winter.temp=[];
    spring.temp=[];
    summer.temp=[];
    autumn.temp=[];
    
% initializing nan
nanVector=NaN(24,1);
nanVector2=NaN(24,2);

for i=Year(1):Year(end)
    % making indexes
    isWinter=M(Year==i)>=12 | M(Year==i)>=1 & M(Year==i)<=2;
    isSpring=M(Year==i)>=3 & M(Year==i)<=5;
    isSummer=M(Year==i)>=6 & M(Year==i)<=8;
    isAutumn=M(Year==i)>=9 & M(Year==i)<=11;
    
    % Assigning structures
    winter.weekend_day=[winter.weekend_day; nanVector; weekend_day(isWinter)];
    spring.weekend_day=[spring.weekend_day; nanVector; weekend_day(isSpring)];
    summer.weekend_day=[summer.weekend_day; nanVector; weekend_day(isSummer)];
    autumn.weekend_day=[autumn.weekend_day; nanVector; weekend_day(isAutumn)];
    
    winter.cat_hour_d=[winter.cat_hour_d; nanVector; cat_hour_d(isWinter)];
    spring.cat_hour_d=[spring.cat_hour_d; nanVector; cat_hour_d(isSpring)];
    summer.cat_hour_d=[summer.cat_hour_d; nanVector; cat_hour_d(isSummer)];
    autumn.cat_hour_d=[autumn.cat_hour_d; nanVector; cat_hour_d(isAutumn)];
    
    winter.cat_day_w=[winter.cat_day_w; nanVector; cat_day_w(isWinter)];
    spring.cat_day_w=[spring.cat_day_w; nanVector; cat_day_w(isSpring)];
    summer.cat_day_w=[summer.cat_day_w; nanVector; cat_day_w(isSummer)];
    autumn.cat_day_w=[autumn.cat_day_w; nanVector2; cat_day_w(isAutumn,1), cat_day_w(isAutumn, 7)];
    
    winter.temp=[winter.temp; nanVector; temp(isWinter)];
    spring.temp=[spring.temp; nanVector; temp(isSpring)];
    summer.temp=[summer.temp; nanVector; temp(isSummer)];
    autumn.temp=[autumn.temp; nanVector; temp(isAutumn)];
    
    winter.power=[winter.power; nanVector; power(isWinter)];
    spring.power=[spring.power; nanVector; power(isSpring)];
    summer.power=[summer.power; nanVector; power(isSummer)];
    autumn.power=[autumn.power; nanVector; power(isAutumn)];
end

% making matrices
winter_power=winter.power;
spring_power=spring.power;
summer_power=summer.power;
autumn_power=autumn.power;

season_power.winter=winter_power;
season_power.spring=spring_power;
season_power.summer=summer_power;
season_power.autumn=autumn_power;

winter=[winter.weekend_day, winter.cat_day_w,  winter.cat_hour_d, winter.temp]; %winter.cat_day_w, 
spring=[spring.weekend_day, spring.cat_day_w, spring.cat_hour_d, spring.temp]; %spring.cat_day_w,
summer=[summer.weekend_day, summer.cat_day_w, summer.cat_hour_d,  summer.temp];%summer.cat_day_w,
autumn=[autumn.weekend_day, autumn.cat_hour_d,  autumn.temp]; %autumn.cat_day_w,



